/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBGL)

#include "JSEXTTextureFilterAnisotropic.h"

#include "EXTTextureFilterAnisotropic.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table for prototype */

static const HashTableValue JSEXTTextureFilterAnisotropicPrototypeTableValues[] =
{
    { "TEXTURE_MAX_ANISOTROPY_EXT", DontDelete | ReadOnly, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEXTTextureFilterAnisotropicTEXTURE_MAX_ANISOTROPY_EXT), (intptr_t)0, NoIntrinsic },
    { "MAX_TEXTURE_MAX_ANISOTROPY_EXT", DontDelete | ReadOnly, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEXTTextureFilterAnisotropicMAX_TEXTURE_MAX_ANISOTROPY_EXT), (intptr_t)0, NoIntrinsic },
    { 0, 0, 0, 0, NoIntrinsic }
};

static const HashTable JSEXTTextureFilterAnisotropicPrototypeTable = { 4, 3, JSEXTTextureFilterAnisotropicPrototypeTableValues, 0 };
const ClassInfo JSEXTTextureFilterAnisotropicPrototype::s_info = { "EXTTextureFilterAnisotropicPrototype", &Base::s_info, &JSEXTTextureFilterAnisotropicPrototypeTable, 0, CREATE_METHOD_TABLE(JSEXTTextureFilterAnisotropicPrototype) };

JSObject* JSEXTTextureFilterAnisotropicPrototype::self(ExecState* exec, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSEXTTextureFilterAnisotropic>(exec, globalObject);
}

bool JSEXTTextureFilterAnisotropicPrototype::getOwnPropertySlot(JSCell* cell, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSEXTTextureFilterAnisotropicPrototype* thisObject = jsCast<JSEXTTextureFilterAnisotropicPrototype*>(cell);
    return getStaticValueSlot<JSEXTTextureFilterAnisotropicPrototype, JSObject>(exec, &JSEXTTextureFilterAnisotropicPrototypeTable, thisObject, propertyName, slot);
}

bool JSEXTTextureFilterAnisotropicPrototype::getOwnPropertyDescriptor(JSObject* object, ExecState* exec, PropertyName propertyName, PropertyDescriptor& descriptor)
{
    JSEXTTextureFilterAnisotropicPrototype* thisObject = jsCast<JSEXTTextureFilterAnisotropicPrototype*>(object);
    return getStaticValueDescriptor<JSEXTTextureFilterAnisotropicPrototype, JSObject>(exec, &JSEXTTextureFilterAnisotropicPrototypeTable, thisObject, propertyName, descriptor);
}

const ClassInfo JSEXTTextureFilterAnisotropic::s_info = { "EXTTextureFilterAnisotropic", &Base::s_info, 0, 0 , CREATE_METHOD_TABLE(JSEXTTextureFilterAnisotropic) };

JSEXTTextureFilterAnisotropic::JSEXTTextureFilterAnisotropic(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<EXTTextureFilterAnisotropic> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSEXTTextureFilterAnisotropic::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(&s_info));
}

JSObject* JSEXTTextureFilterAnisotropic::createPrototype(ExecState* exec, JSGlobalObject* globalObject)
{
    return JSEXTTextureFilterAnisotropicPrototype::create(exec->vm(), globalObject, JSEXTTextureFilterAnisotropicPrototype::createStructure(globalObject->vm(), globalObject, globalObject->objectPrototype()));
}

void JSEXTTextureFilterAnisotropic::destroy(JSC::JSCell* cell)
{
    JSEXTTextureFilterAnisotropic* thisObject = static_cast<JSEXTTextureFilterAnisotropic*>(cell);
    thisObject->JSEXTTextureFilterAnisotropic::~JSEXTTextureFilterAnisotropic();
}

JSEXTTextureFilterAnisotropic::~JSEXTTextureFilterAnisotropic()
{
    releaseImplIfNotNull();
}

// Constant getters

JSValue jsEXTTextureFilterAnisotropicTEXTURE_MAX_ANISOTROPY_EXT(ExecState* exec, JSValue, PropertyName)
{
    UNUSED_PARAM(exec);
    return jsNumber(static_cast<int>(0x84FE));
}

JSValue jsEXTTextureFilterAnisotropicMAX_TEXTURE_MAX_ANISOTROPY_EXT(ExecState* exec, JSValue, PropertyName)
{
    UNUSED_PARAM(exec);
    return jsNumber(static_cast<int>(0x84FF));
}

static inline bool isObservable(JSEXTTextureFilterAnisotropic* jsEXTTextureFilterAnisotropic)
{
    if (jsEXTTextureFilterAnisotropic->hasCustomProperties())
        return true;
    return false;
}

bool JSEXTTextureFilterAnisotropicOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    JSEXTTextureFilterAnisotropic* jsEXTTextureFilterAnisotropic = jsCast<JSEXTTextureFilterAnisotropic*>(handle.get().asCell());
    if (!isObservable(jsEXTTextureFilterAnisotropic))
        return false;
    WebGLRenderingContext* root = jsEXTTextureFilterAnisotropic->impl()->context();
    return visitor.containsOpaqueRoot(root);
}

void JSEXTTextureFilterAnisotropicOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSEXTTextureFilterAnisotropic* jsEXTTextureFilterAnisotropic = jsCast<JSEXTTextureFilterAnisotropic*>(handle.get().asCell());
    DOMWrapperWorld* world = static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, jsEXTTextureFilterAnisotropic->impl(), jsEXTTextureFilterAnisotropic);
    jsEXTTextureFilterAnisotropic->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7EXTTextureFilterAnisotropic@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore27EXTTextureFilterAnisotropicE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, EXTTextureFilterAnisotropic* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSEXTTextureFilterAnisotropic>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7EXTTextureFilterAnisotropic@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore27EXTTextureFilterAnisotropicE[2];
#if COMPILER(CLANG) && COMPILER_SUPPORTS(CXX_STATIC_ASSERT)
    // If this fails EXTTextureFilterAnisotropic does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(EXTTextureFilterAnisotropic), EXTTextureFilterAnisotropic_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // EXTTextureFilterAnisotropic has subclasses. If EXTTextureFilterAnisotropic has subclasses that get passed
    // to toJS() we currently require EXTTextureFilterAnisotropic you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<EXTTextureFilterAnisotropic>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSEXTTextureFilterAnisotropic>(exec, globalObject, impl);
}

EXTTextureFilterAnisotropic* toEXTTextureFilterAnisotropic(JSC::JSValue value)
{
    return value.inherits(&JSEXTTextureFilterAnisotropic::s_info) ? jsCast<JSEXTTextureFilterAnisotropic*>(asObject(value))->impl() : 0;
}

}

#endif // ENABLE(WEBGL)
